/**
 * RTOQTYQTY.java
 *
 * File generated from the medication::RTOQTYQTY uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class RTOQTYQTY.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RTO_QTY_QTY", propOrder = {
	"numerator",
	"denominator"
})
@XmlRootElement(name = "RTO_QTY_QTY")
public class RTOQTYQTY extends net.ihe.gazelle.medication.QTY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                          The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                      .
	 */
	@XmlElement(name = "numerator", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.QTY numerator;
	/**
	 *                          The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                      .
	 */
	@XmlElement(name = "denominator", required = true, namespace = "urn:epsos-org:ep:medication")
	public net.ihe.gazelle.medication.QTY denominator;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return numerator.
	 * @return numerator :                          The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                      
	 */
	public net.ihe.gazelle.medication.QTY getNumerator() {
	    return numerator;
	}
	
	/**
	 * Set a value to attribute numerator.
	 * @param numerator :                          The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                                               The quantity that is being
	                                divided in the ratio.  The                         default is the
	                                integer number 1 (one).                      .
	 */
	public void setNumerator(net.ihe.gazelle.medication.QTY numerator) {
	    this.numerator = numerator;
	}
	
	
	
	
	/**
	 * Return denominator.
	 * @return denominator :                          The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                      
	 */
	public net.ihe.gazelle.medication.QTY getDenominator() {
	    return denominator;
	}
	
	/**
	 * Set a value to attribute denominator.
	 * @param denominator :                          The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                                               The quantity that devides the
	                                numerator in the ratio.                         The default is the
	                                integer number 1 (one).                         The denominator must
	                                not be zero.                      .
	 */
	public void setDenominator(net.ihe.gazelle.medication.QTY denominator) {
	    this.denominator = denominator;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "RTO_QTY_QTY").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(RTOQTYQTY rTOQTYQTY, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (rTOQTYQTY != null){
   			net.ihe.gazelle.medication.QTY.validateByModule(rTOQTYQTY, location, cvm, diagnostic);
			net.ihe.gazelle.medication.QTY.validateByModule(rTOQTYQTY.getNumerator(), location + "/numerator", cvm, diagnostic);
			net.ihe.gazelle.medication.QTY.validateByModule(rTOQTYQTY.getDenominator(), location + "/denominator", cvm, diagnostic);
    	}
    }

}